
//Graphic Objects V1.01
//For MikroC
//Author: BitWise

#ifndef F_OBJECTS

typedef unsigned int Color;

typedef struct {
  int X;
  int Y;
}PointF;

typedef struct {
 int Width;
 int Height;
}SizeF;

typedef struct {
 PointF Position;
 SizeF Size;
}RectF;

typedef struct {
 PointF Center;
 unsigned int Radius;
}CircleF;

typedef struct {
 unsigned char res1;
 unsigned char res2;
 unsigned char res3;
 unsigned char res4;
}Dash;

typedef struct {
 char Thickness;
 Color Color;
 Dash Style;
}Pen;

const double PI = 3.141592654;
const double RAD = 57.2958;

#define F_OBJECTS

#endif