#line 1 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
#line 18 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
void ADXL345_Write(unsigned short address, unsigned short data1);
unsigned short ADXL345_Read(unsigned short address);
char ADXL345_Init(void);


int Accel_ReadX(void);


int Accel_ReadY(void);


int Accel_ReadZ(void);

char out[16];
int readings[3] = {0, 0, 0};
extern char cACCEL_test_status;

extern struct rot_xform{
 float x;
 float y;
 float z;
 } rotate;

extern char rotationString[120];
#line 50 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
void ADXL345_Write(unsigned short address, unsigned short data1)
{
 I2C2_Start();
 I2C2_Write(0x3A);
 I2C2_Write(address);
 I2C2_Write(data1);
 I2C2_Stop();
}
#line 66 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
unsigned short ADXL345_Read(unsigned short address)
{
 unsigned short tmp = 0;

 I2C2_Start();
 I2C2_Write(0x3A);
 I2C2_Write(address);

 I2C2_Start();
 I2C2_Write(0x3B);
 tmp = I2C2_Read(1);
 I2C2_Stop();

 return tmp;
}
#line 89 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
char ADXL345_Init(void)
{
 char id = 0x00;


 ADXL345_Write(0x2D, 0x00);

 id = ADXL345_Read(0x00);

 if (id != 0xE5)
 {
 return  0x02 ;
 }
 else
 {
 ADXL345_Write( 0x31 , 0x08);
 ADXL345_Write( 0x2C , 0x0A);
 ADXL345_Write( 0x38 , 0x80);
 ADXL345_Write( 0x2D , 0x08);
 return 0x00;
 }
}
#line 119 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
int Accel_ReadX(void)
{
 char low_byte;
 int Out_x;

 Out_x = ADXL345_Read( 0x33 );
 low_byte = ADXL345_Read( 0x32 );

 Out_x = (Out_x << 8);
 Out_x = (Out_x | low_byte);

 return Out_x;
}
#line 140 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
int Accel_ReadY(void)
{
 char low_byte;
 int Out_y;

 Out_y = ADXL345_Read( 0x35 );
 low_byte = ADXL345_Read( 0x34 );

 Out_y = (Out_y << 8);
 Out_y = (Out_y | low_byte);

 return Out_y;
}
#line 161 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
int Accel_ReadZ(void)
{
 char low_byte;
 int Out_z;

 Out_z = ADXL345_Read( 0x37 );
 low_byte = ADXL345_Read( 0x36 );

 Out_z = (Out_z << 8);
 Out_z = (Out_z | low_byte);

 return Out_z;
}
#line 186 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
void Accel_Average(void)
{
 int i, sx, sy, sz;


 sx = sy = sz = 0;


 for (i=0; i<16; i++){
 sx += Accel_ReadX();
 sy += Accel_ReadY();
 sz += Accel_ReadZ();
 }


 readings[0] = sx >> 4;
 readings[1] = sy >> 4;
 readings[2] = sz >> 4;
}
#line 214 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
void ACCEL_Start(char *test)
{

 *test = 0;


 I2C2_Init(250000);


 if (ADXL345_Init() == 0)
 {

 *test = 1;
 Delay_ms(500);
 } else {

 *test = 2;
 }
}
#line 241 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/accel_driver.c"
void ACCEL_Test(void)
{

 char x_out[15];
 char y_out[15];
 char z_out[15];

 Accel_Average();



 rotate.x = (float)readings[0] * 0.35;

 rotate.y = ((float)readings[1] * 0.35);



 IntToStr((int)rotate.x, x_out);
 IntToStr((int)rotate.y, y_out);



 strcpy(rotationString, "Rotate    X: ");
 strcat(rotationString, x_out);

 strcat(rotationString, "     Y: ");
 strcat(rotationString, y_out);



}
