#line 1 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/bounce_events_code.c"
#line 1 "m:/data/personal/development/mcu/pic32 bounce soccer demo/development/bounce_code/mikroc pro for pic32/bounce_objects.h"
typedef struct Screen TScreen;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
};

extern TScreen soccerField;




void animateBallOnClick();
void ballOnPress();






void DrawScreen(TScreen *aScreen);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "m:/data/personal/development/mcu/pic32 bounce soccer demo/development/bounce_code/mikroc pro for pic32/bounce_resources.h"
#line 1 "m:/data/personal/development/mcu/pic32 bounce soccer demo/development/bounce_code/mikroc pro for pic32/game_settings.h"
#line 32 "m:/data/personal/development/mcu/pic32 bounce soccer demo/development/bounce_code/mikroc pro for pic32/game_settings.h"
sbit upButton at PORTA.B6;
sbit downButton at PORTA.B7;
sbit rightButton at PORTD.B10;
sbit leftButton at PORTA.B5;
sbit triangleButton at PORTD.B14;
sbit xButton at PORTD.B15;
sbit circleButton at PORTF.B4;
sbit squareButton at PORTD.B11;
sbit startButton at PORTF.B5;







struct clear_region{
 int top;
 int left;
 int bottom;
 int right;
};

struct GFX_Rect{
 int x;
 int y;
 int w;
 int h;
};


struct ball_object {

 int x;
 int y;

 int w;
 int h;

 int prev_x;
 int prev_y;

 int direction_x;
 int direction_y;

 int prev_direction_x;
 int prev_direction_y;

 int frame;

 int x_speed;
 int y_speed;
};



struct character_object {

 int x;
 int y;

 int w;
 int h;

 int prev_x;
 int prev_y;

 int direction_x;
 int direction_y;

 int prev_direction_x;
 int prev_direction_y;

 int frame;
 int speed;
 int score;
 int prev_score;
};




int top_side = 19;
int lower_side = 35;


int screen_dirty = 0;


unsigned long frame_counter = 0;
#line 1 "m:/data/personal/development/mcu/pic32 bounce soccer demo/development/bounce_code/mikroc pro for pic32/bwi_resources.h"



const code char ball_01_bwi[978];

const code char ball_02_bwi[978];

const code char ball_03_bwi[978];

const code char ball_04_bwi[978];

const code char ball_05_bwi[978];

const code char ball_06_bwi[978];

const code char ball_07_bwi[978];

const code char ball_08_bwi[978];

const code char ball_09_bwi[978];

const code char ball_10_bwi[978];

const code char ball_11_bwi[978];

const code char ball_12_bwi[978];

const code char ball_13_bwi[978];

const code char ball_14_bwi[978];

const code char ball_15_bwi[978];
#line 1 "m:/data/personal/development/mcu/pic32 bounce soccer demo/development/bounce_code/mikroc pro for pic32/_bwo_lib.h"







typedef unsigned int Color;

typedef struct {
 int X;
 int Y;
}PointF;

typedef struct {
 int Width;
 int Height;
}SizeF;

typedef struct {
 PointF Position;
 SizeF Size;
}RectF;

typedef struct {
 PointF Center;
 unsigned int Radius;
}CircleF;

typedef struct {
 unsigned char res1;
 unsigned char res2;
 unsigned char res3;
 unsigned char res4;
}Dash;

typedef struct {
 char Thickness;
 Color Color;
 Dash Style;
}Pen;

const double PI = 3.141592654;
const double RAD = 57.2958;
#line 9 "M:/Data/Personal/Development/MCU/PIC32 Bounce Soccer Demo/Development/bounce_Code/mikroC PRO for PIC32/bounce_events_code.c"
PointF ball_pos;

void Set_Defaults();
void Start_Game();
void Get_Input();
void Animate_Ball();
int Render_Screen();
void SavePrevious();

extern struct rot_xform{
 float x;
 float y;
 float z;
} rotate;

char IsCollision (unsigned int Shape_X, unsigned int Shape_Y, unsigned int Shape_Width, unsigned int Shape_Height, unsigned int Player_Left, unsigned int Player_Top, unsigned int Player_Width, unsigned int Player_Height);

const animation_address;
unsigned running;
struct ball_object the_ball;

void Start_Game(){

 if(running == 0){
 ball_pos.X = the_ball.x;
 ball_pos.Y = the_ball.y;


 TFT_Set_Pen( 0x03E6 , 1);

 TFT_Set_Brush(1,  0x03E6 , 0, TOP_TO_BOTTOM,  0x03E6 ,  0x03E6 );


 TFT_Rectangle(0, 0,  320 ,  240 );
 }


 running=1;
}

void Set_Defaults() {




 TRISA.B6 = 1;
 TRISA.B7 = 1;
 TRISD.B10 = 1;
 TRISA.B5 = 1;

 TRISD.B14 = 1;
 TRISD.B15 = 1;
 TRISF.B4 = 1;
 TRISD.B11 = 1;

 TRISF.B5 = 1;

 running = 0;
 frame_counter = 0;

 the_ball.frame = 1;

 the_ball.x =  320 /2;
 the_ball.y =  240 /2;

 the_ball.w = 22;
 the_ball.h = 22;

 the_ball.direction_x = 1;
 the_ball.direction_y = -1;

 the_ball.x_speed =  12 ;
 the_ball.y_speed =  6 ;
}


void Get_Input(){


 if((abs(rotate.x)/2) > 10){
 the_ball.x_speed =  12 ;
 } else {
 the_ball.x_speed = abs(rotate.x)/2;
 }


 if((abs(rotate.y)/2) > 10){
 the_ball.y_speed =  6 ;
 } else {
 the_ball.y_speed = abs(rotate.y)/2;
 }

 if(rotate.x > 5){
 the_ball.direction_x = 1;
 } else if (rotate.x < -5){
 the_ball.direction_x = -1;
 } else {
 the_ball.direction_x = 0;
 the_ball.x_speed =  0 ;
 }


 if(rotate.y > 5){
 the_ball.direction_y = 1;
 } else if (rotate.y < -5){
 the_ball.direction_y = -1;
 } else {
 the_ball.direction_y = 0;
 the_ball.y_speed =  0 ;
 }
}


void Animate_Ball(){

 if(the_ball.x < (5+the_ball.x_speed)){
 the_ball.direction_x = -1;
 ~the_ball.direction_y;
 the_ball.x_speed =  0 +1;
 }


 else if(the_ball.x > (( 320 )-the_ball.w) ){
 the_ball.direction_x = 1;
 ~the_ball.direction_y;
 the_ball.x_speed =  0 +1;
 }


 if(the_ball.y < (5+the_ball.y_speed)){
 the_ball.direction_y = -1;
 ~the_ball.direction_x;
 the_ball.y_speed =  0 +1;
 }


 else if(the_ball.y > (( 240 )-the_ball.h) ){
 the_ball.direction_y = 1;
 ~the_ball.direction_x;
 the_ball.y_speed =  0 +1;
 }


 if( (the_ball.prev_direction_x != the_ball.direction_x) ||
 (the_ball.prev_direction_y != the_ball.direction_y) ){


 }


 if((frame_counter % 8) == 1){

 if(the_ball.x_speed >  0 ){
 the_ball.x_speed--;
 }

 if(the_ball.y_speed >  0 ){
 the_ball.y_speed--;
 }
 }


 if(the_ball.x_speed <  0 ){
 the_ball.x_speed =  0 ;
 }


 if(the_ball.y_speed <  0 ){
 the_ball.y_speed =  0 ;
 }


 the_ball.x -= the_ball.direction_x * the_ball.x_speed;
 the_ball.y -= the_ball.direction_y * the_ball.y_speed;


 if( (the_ball.x_speed >=5) || (the_ball.y_speed >=5) ) {
 if(the_ball.direction_x == 1) {
 the_ball.frame++;
 }
 else {
 the_ball.frame--;
 }
 }
 else if( (the_ball.x_speed >=3) || (the_ball.y_speed >=3) ) {
 if( (frame_counter % 2 ) == 0){
 if(the_ball.direction_x == 1) {
 the_ball.frame++;
 } else {
 the_ball.frame--;
 }
 }
 } else if ((the_ball.x_speed >=1) || (the_ball.y_speed >=1) ) {
 if( (frame_counter % 4 ) == 0){
 if(the_ball.direction_x == 1) {
 the_ball.frame++;
 } else {
 the_ball.frame--;
 }
 }
 }


 if (the_ball.frame > 15){
 the_ball.frame = 1;
 } else if (the_ball.frame <= 0){
 the_ball.frame = 15;
 }

 ball_pos.X = the_ball.x;
 ball_pos.Y = the_ball.y;

 switch (the_ball.frame) {
 case 1:
 image_bwi(ball_pos, ball_01_bwi);
 break;

 case 2:
 image_bwi(ball_pos, ball_02_bwi);
 break;

 case 3:
 image_bwi(ball_pos, ball_03_bwi);
 break;

 case 4:
 image_bwi(ball_pos, ball_04_bwi);
 break;

 case 5:
 image_bwi(ball_pos, ball_05_bwi);
 break;

 case 6:
 image_bwi(ball_pos, ball_06_bwi);
 break;

 case 7:
 image_bwi(ball_pos, ball_07_bwi);
 break;

 case 8:
 image_bwi(ball_pos, ball_08_bwi);
 break;

 case 9:
 image_bwi(ball_pos, ball_09_bwi);
 break;

 case 10:
 image_bwi(ball_pos, ball_10_bwi);
 break;

 case 11:
 image_bwi(ball_pos, ball_11_bwi);
 break;

 case 12:
 image_bwi(ball_pos, ball_12_bwi);
 break;

 case 13:
 image_bwi(ball_pos, ball_13_bwi);
 break;

 case 14:
 image_bwi(ball_pos, ball_14_bwi);
 break;

 case 15:
 image_bwi(ball_pos, ball_15_bwi);
 break;

 default:
 image_bwi(ball_pos, ball_01_bwi);
 break;
 }
}



char IsCollision (unsigned int Shape_X, unsigned int Shape_Y, unsigned int Shape_Width, unsigned int Shape_Height, unsigned int Player_Left, unsigned int Player_Top, unsigned int Player_Width, unsigned int Player_Height) {



 if( ((Shape_X + Shape_Width) >= Player_Left ) && ((Shape_X) <= (Player_Left + Player_Width-1)) &&



 ((Shape_Y + Shape_Height) >= Player_Top ) && ((Shape_Y) <= (Player_Top + Player_Height-1)) ) {




 return 1;
 } else {


 return 0;
 }
}

int Render_Screen() {

 if (running != 1)
 return 0;


 Delay_ms(30);

 frame_counter++;


 TFT_Set_Pen( 0x03E6 , 1);


 TFT_Set_Brush(1,  0x03E6 , 0, TOP_TO_BOTTOM,  0x03E6 ,  0x03E6 );

 if(the_ball.y < 0)
 the_ball.y =  240 /2;

 if(the_ball.x < 0)
 the_ball.x =  320 /2;

 if(the_ball.prev_y < 0)
 the_ball.prev_y =  240 /2;

 if(the_ball.prev_x < 0)
 the_ball.prev_x =  320 /2;




 TFT_Rectangle(the_ball.x, the_ball.y, the_ball.x+the_ball.w, the_ball.y+the_ball.h);

 Animate_Ball();

 SavePrevious();

 return 1;
}


void SavePrevious(){

 the_ball.prev_x = the_ball.x;
 the_ball.prev_y = the_ball.y;


 the_ball.prev_direction_x = the_ball.direction_x;
 the_ball.prev_direction_y = the_ball.direction_y;
}
