# Soccer Bounce Demo for Mikromedia PIC32 #
-------------------------
2015-01-17

Created by Andrew Hazelden   
Twitter: [@andrewhazelden](https://twitter.com/andrewhazelden)  
Email: [andrew@andrewhazelden.com](mailto:andrew@andrewhazelden.com)  
Web: [www.andrewhazelden.com](http://www.andrewhazelden.com)  

## Overview ##

The Soccer Bounce demo uses the accelerometer input to roll a soccer ball around on a Mikromedia PIC32 screen. The code was written using MikroC Pro for PIC32 and VisualTFT. 

The soccer ball sprite graphics are rendered using Dragan Regodic's excellent TFT Graphics library:  
[http://www.libstock.com/projects/view/914/tft-graphics-library](http://www.libstock.com/projects/view/914/tft-graphics-library)

## Screenshot ##

![Rolling the Soccer ball](Screenshot/Bounce.jpg)  

YouTube Video:  
[`https://www.youtube.com/watch?v=Xb_D_DsTg8E`](https://www.youtube.com/watch?v=Xb_D_DsTg8E)

## Installation ##

1. Install Firmware: Flash the firmware file bounce.hex to your Mikromedia PIC32 board.

2. Enjoy the demo by tipping the Mikromedia board to roll the soccer ball around the screen.

## Hardware Required ##

`MikroMMB_for_PIC32_hw_rev_1.10`  
[http://www.mikroe.com/mikromedia/pic32/](http://www.mikroe.com/mikromedia/pic32/)`
               
